cascading.stats

## Class FlowStats

- java.lang.Object
- - cascading.stats.CascadingStats<FlowStepStats>
  - - cascading.stats.FlowStats

All Implemented Interfaces:
  ProvidesCounters, java.io.Serializable

Direct Known Subclasses:
  ProcessFlowStats

    public class FlowStats
    extends CascadingStats<FlowStepStats>

Class FlowStats collects `Flow` specific statistics.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class cascading.stats.CascadingStats

`CascadingStats.Status, CascadingStats.Type`

### Field Summary

### Fields inherited from class cascading.stats.CascadingStats

`clientState, finishedTime, lastCaptureDetail, listeners, name, pendingTime, runTime, startTime, STATS_COMPLETE_CHILD_DETAILS_BLOCK_DURATION, STATS_STORE_INTERVAL, status, submitTime, throwable, throwableTrace`

### Constructor Summary

Constructors
Constructor and Description
`FlowStats(Flow flow, ClientState clientState)`

### Method Summary

Methods
`void` `addStepStats(FlowStepStats flowStepStats)`
`void` `captureDetail(CascadingStats.Type depth)`
`boolean` `equals(java.lang.Object object)`
`java.lang.String` `getAppID()`
`java.lang.String` `getAppName()`
`java.util.Collection<FlowStepStats>` `getChildren()` Method getChildren returns any relevant child statistics instances.
`FlowStepStats` `getChildWith(java.lang.String id)` Method getChildWith returns a child stats instance with the given ID value.
`java.util.Collection<java.lang.String>` `getCounterGroups()` Method getCounterGroups returns all the available counter group names.
`java.util.Collection<java.lang.String>` `getCounterGroupsMatching(java.lang.String regex)` Method getCounterGroupsMatching returns all the available counter group names that match the given regular expression.
`java.util.Collection<java.lang.String>` `getCountersFor(java.lang.String group)` Method getCountersFor returns all the counter names for the give group name.
`long` `getCounterValue(java.lang.Enum counter)` Method getCounter returns the current value for the given counter Enum.
`long` `getCounterValue(java.lang.String group, java.lang.String counter)` Method getCounter returns the current value for the given group and counter.
`Flow` `getFlow()`
`java.util.Map<java.lang.Object,java.lang.Object>` `getFlowProperties()`
`java.util.List<FlowStepStats>` `getFlowStepStats()` Method getStepStats returns the stepStats owned by this FlowStats.
`java.lang.String` `getID()` Method getID returns the ID of this CascadingStats object.
`long` `getLastSuccessfulCounterFetchTime()` Method getLastSuccessfulCounterFetchTime returns the time, in millis, the last moment counters were successfully retrieved.
`protected ProcessLogger` `getProcessLogger()`
`protected java.lang.String` `getStatsString()`
`int` `getStepsCount()` Method getStepsCount returns the number of steps this Flow executed.
`CascadingStats.Type` `getType()`
`int` `hashCode()`
`void` `recordInfo()`
`java.lang.String` `toString()`

### Methods inherited from class cascading.stats.CascadingStats

`addListener, captureDetail, cleanup, fireListeners, getCountersFor, getCurrentDuration, getDuration, getFinishedTime, getName, getPendingTime, getPrefix, getRunTime, getStartTime, getStatus, getSubmitTime, getThrowable, getThrowableTrace, isDetailStale, isEngaged, isFailed, isFinished, isPending, isRunning, isSkipped, isStarted, isStopped, isSubmitted, isSuccessful, logDebug, logError, logError, logInfo, logWarn, markDetailCaptured, markFailed, markFailed, markFailed, markFailed, markFinishedTime, markPending, markPendingTime, markRunning, markRunTime, markSkipped, markStarted, markStartedThenRunning, markStartTime, markStartToRunTime, markStopped, markSubmitted, markSubmitTime, markSuccessful, prepare, recordStats, removeListener, setStatsStoreInterval`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### FlowStats

    public FlowStats(Flow flow,
             ClientState clientState)

### Method Detail

#### getProcessLogger

    protected ProcessLogger getProcessLogger()

Specified by:
  `getProcessLogger` in class `CascadingStats<FlowStepStats>`

#### getFlowProperties

    public java.util.Map<java.lang.Object,java.lang.Object> getFlowProperties()

#### getAppID

    public java.lang.String getAppID()

#### getAppName

    public java.lang.String getAppName()

#### getID

    public java.lang.String getID()

Description copied from class: `CascadingStats`
Method getID returns the ID of this CascadingStats object.

Specified by:
  `getID` in class `CascadingStats<FlowStepStats>`
Returns:
  the ID (type Object) of this CascadingStats object.

#### getType

    public CascadingStats.Type getType()

Specified by:
  `getType` in class `CascadingStats<FlowStepStats>`

#### getFlow

    public Flow getFlow()

#### recordInfo

    public void recordInfo()

Specified by:
  `recordInfo` in class `CascadingStats<FlowStepStats>`

#### addStepStats

    public void addStepStats(FlowStepStats flowStepStats)

#### getFlowStepStats

    public java.util.List<FlowStepStats> getFlowStepStats()

Method getStepStats returns the stepStats owned by this FlowStats.

Returns:
  the stepStats (type List<StepStats>) of this FlowStats object.

#### getStepsCount

    public int getStepsCount()

Method getStepsCount returns the number of steps this Flow executed.

Returns:
  the stepsCount (type int) of this FlowStats object.

#### getLastSuccessfulCounterFetchTime

    public long getLastSuccessfulCounterFetchTime()

Description copied from interface: `ProvidesCounters`
Method getLastSuccessfulCounterFetchTime returns the time, in millis, the last moment counters were successfully retrieved.

If -1, counter values were never successfully retrieved.

If this return value is less than the `CascadingStats.getFinishedTime()` it is likely the counter service became unavailable.

Returns:
  the moment counters were last successfully retrieved

#### getCounterGroups

    public java.util.Collection<java.lang.String> getCounterGroups()

Description copied from interface: `ProvidesCounters`
Method getCounterGroups returns all the available counter group names.

Returns:
  the counterGroups (type Collection<String>) of this CascadingStats object.

#### getCounterGroupsMatching

    public java.util.Collection<java.lang.String> getCounterGroupsMatching(java.lang.String regex)

Description copied from class: `CascadingStats`
Method getCounterGroupsMatching returns all the available counter group names that match the given regular expression.

Specified by:
  `getCounterGroupsMatching` in class `CascadingStats<FlowStepStats>`
Parameters:
  `regex` - of type String
Returns:
  Collection<String>

#### getCountersFor

    public java.util.Collection<java.lang.String> getCountersFor(java.lang.String group)

Description copied from interface: `ProvidesCounters`
Method getCountersFor returns all the counter names for the give group name.

Returns:
  Collection<String>

#### getCounterValue

    public long getCounterValue(java.lang.Enum counter)

Description copied from interface: `ProvidesCounters`
Method getCounter returns the current value for the given counter Enum.

Parameters:
  `counter` - of type Enum
Returns:
  the current counter value

#### getCounterValue

    public long getCounterValue(java.lang.String group,
                       java.lang.String counter)

Description copied from interface: `ProvidesCounters`
Method getCounter returns the current value for the given group and counter.

Parameters:
  `group` - of type String
  `counter` - of type String
Returns:
  the current counter value

#### captureDetail

    public void captureDetail(CascadingStats.Type depth)

Specified by:
  `captureDetail` in class `CascadingStats<FlowStepStats>`

#### getChildren

    public java.util.Collection<FlowStepStats> getChildren()

Description copied from class: `CascadingStats`
Method getChildren returns any relevant child statistics instances. They may not be of type CascadingStats, but instead platform specific.

Specified by:
  `getChildren` in class `CascadingStats<FlowStepStats>`
Returns:
  a Collection of child statistics

#### getChildWith

    public FlowStepStats getChildWith(java.lang.String id)

Description copied from class: `CascadingStats`
Method getChildWith returns a child stats instance with the given ID value.

Specified by:
  `getChildWith` in class `CascadingStats<FlowStepStats>`
Parameters:
  `id` - the id of a child instance
Returns:
  the child stats instance or null if not found

#### getStatsString

    protected java.lang.String getStatsString()

Overrides:
  `getStatsString` in class `CascadingStats<FlowStepStats>`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `CascadingStats<FlowStepStats>`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `java.lang.Object`

#### equals

    public boolean equals(java.lang.Object object)

Overrides:
  `equals` in class `java.lang.Object`